; # by Seth Burgess <sjburges@gimp.org>
;
; #[Xach] start off with an image, then pixelize it
; #[Xach] then add alpha->add layer mask                                   [20:21]
; #[Xach] render a checkerboard into the layer mask
; #[Xach] duplicate the image. fill the original with black, then blur the layer 
; #           mask (i used 30% of pixelize size) and offset it by some value (i 
; #           chose 20% of the pixelize size)
; #[Xach] duplicate the duplicate, remove the layer mask, move it below everything
; #[Xach] then add a new white layer on top, set the mode to multiply, and render 
; #           a grid into it at pixelize size
; #[Xach] that's a bit roundabout, but it's also in the xcf
; #
; # Because the way xach does it is a bit ackward, I'm switching it around a bit
; # and working from the bottom up..
; 
; # Revision 1.1: Marc Lehman <pcg@goof.com> added undo capability
; # Revision 1.2: Marc Lehman <pcg@goof.com>, changed function name
; # Revision 1.3: Seth Burgess <sjburges@gimp.org>, changed location and 
; #                 added my email address
; #
; # Here's the boring start of every script...
; 
; The original Perl-Fu script was written by Seth Burgess
; See gimp/plug-ins/perl/examples/* in source archives
; 
; Translated into Script-Fu by Iccii <iccii@hotmail.com>
;
; --------------------------------------------------------------------
; version 0.1  by Iccii 2001/12/02
;     - Initial relase
;
; --------------------------------------------------------------------

(define (script-fu-perl-xach-shadow
			img drawable blocksize gridari?)

;add 2.4
  (let (
       (selection-flag 0)
       (oldbackground 0)
       (shadowlayer 0)
       (checkmask 0)
       (frontlayer 0)
       (gridlayer 0)
       )


	(gimp-image-undo-group-start img)

; #	(set! selection-flag 0)
	(if (not (equal? (car (gimp-drawable-has-alpha drawable)) TRUE))
	    (gimp-layer-add-alpha drawable))
; # This only can be applied to an entire image right now..	
; #	(set! selection (car (gimp-selection-save img)))
	(gimp-selection-all img)
	(set! oldbackground (car (gimp-palette-get-background)))
; # Now the fun begins :) 
	(plug-in-pixelize 1 img drawable blocksize)
	(set! shadowlayer (car (gimp-layer-copy drawable 0)))
	(gimp-image-add-layer img shadowlayer 0)
	(set! checkmask (car (gimp-layer-create-mask shadowlayer ADD-WHITE-MASK)))
	(gimp-layer-add-mask shadowlayer checkmask)
	(plug-in-checkerboard 1 img checkmask 0 blocksize)

	(set! frontlayer (car (gimp-layer-copy shadowlayer 0)))
	(gimp-image-add-layer img frontlayer 0)
	(gimp-palette-set-background '(0 0 0))
	(gimp-drawable-fill shadowlayer BACKGROUND-FILL)
	(plug-in-gauss-iir 1 img checkmask (* 0.3 blocksize) 1 1)
	(gimp-drawable-offset checkmask 1 0 (* 0.2 blocksize) (* 0.2 blocksize))




	(set! gridlayer (car (gimp-layer-new img (car (gimp-image-width img))
	                                     (car (gimp-image-height img))
	                                     RGBA-IMAGE "Grid 1" 100 0)))
(if (= gridari? TRUE)
(begin
	(gimp-image-add-layer img gridlayer 0)
	(gimp-selection-all img)
	(gimp-edit-clear gridlayer)
	(gimp-palette-set-background '(255 255 255))
	(gimp-edit-fill gridlayer BACKGROUND-FILL)
	(plug-in-grid 1 img gridlayer 1 blocksize 0 '(0 0 0) 255
	              1 blocksize 0 '(0 0 0) 255 1 blocksize 0 '(0 0 0) 255)
))
	(gimp-layer-set-mode gridlayer 3)

; # Clean up stuff
	(gimp-palette-set-background oldbackground)

;merge layers
;;(set! final-layer (car (gimp-image-merge-down img shadowlayer EXPAND-AS-NECESSARY)))
;(if (eqv? (car (gimp-selection-is-empty img)) FALSE)
;    (begin
;        (gimp-selection-invert img)
;        (gimp-edit-clear final-layer)))
;(set! final-layer (car (gimp-image-merge-down img frontlayer EXPAND-AS-NECESSARY)))
;(if (eqv? (car (gimp-selection-is-empty img)) FALSE)
;    (begin
;        (gimp-selection-invert img)
;        (gimp-edit-clear final-layer)))
;(if (= gridari? TRUE)
;(begin
;(set! final-layer (car (gimp-image-merge-down img gridlayer EXPAND-AS-NECESSARY)))
;(if (eqv? (car (gimp-selection-is-empty img)) FALSE)
;    (begin
;        (gimp-selection-invert img)
;        (gimp-edit-clear final-layer)))
;))
	(gimp-image-merge-visible-layers img 1)

        (gimp-selection-none img)
	(gimp-image-undo-group-end img)
	(gimp-displays-flush)

;2.4ǉ(let)
 )
)

(script-fu-register
  "script-fu-perl-xach-shadow"
  "<Image>/Script-Fu/Filters/Xach Shadows..."
  "Xach's Shadows o' Fun"
  "Seth Burgess"
  "kaizou by kiki"
  "3-11-04"
  "RGB*"
  SF-IMAGE      "Image"       0
  SF-DRAWABLE   "Drawable"    0
  SF-ADJUSTMENT "Block Size"  '(10 4 255 1 1 0 0)
  SF-TOGGLE     "Grid"        FALSE
)
